/*
* Licensed to the Apache Software Foundation (ASF) under one or more
* contributor license agreements.  See the NOTICE file distributed with
* this work for additional information regarding copyright ownership.
* The ASF licenses this file to You under the Apache License, Version 2.0
* (the "License"); you may not use this file except in compliance with
* the License.  You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

    package com.ywt.gapi.taihe.biz;

import org.apache.dubbo.common.stream.StreamObserver;
import com.google.protobuf.Message;

import java.util.HashMap;
import java.util.Map;
import java.util.function.BiConsumer;
import java.util.concurrent.CompletableFuture;

public interface TaiheBizService extends org.apache.dubbo.rpc.model.DubboStub {

    String JAVA_SERVICE_NAME = "com.ywt.gapi.taihe.biz.TaiheBizService";
    String SERVICE_NAME = "com.ywt.gapi.taihe.biz.TaiheBizService";

    com.ywt.gapi.taihe.biz.MriBaseResponse mriBooking(com.ywt.gapi.taihe.biz.MriBookingRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.biz.MriBaseResponse> mriBookingAsync(com.ywt.gapi.taihe.biz.MriBookingRequest request){
        return CompletableFuture.completedFuture(mriBooking(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void mriBooking(com.ywt.gapi.taihe.biz.MriBookingRequest request, StreamObserver<com.ywt.gapi.taihe.biz.MriBaseResponse> responseObserver){
        mriBookingAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

    com.ywt.gapi.taihe.biz.GetScreeningTableResponse getScreeningTable(com.ywt.gapi.taihe.biz.GetScreeningTableRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.biz.GetScreeningTableResponse> getScreeningTableAsync(com.ywt.gapi.taihe.biz.GetScreeningTableRequest request){
        return CompletableFuture.completedFuture(getScreeningTable(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getScreeningTable(com.ywt.gapi.taihe.biz.GetScreeningTableRequest request, StreamObserver<com.ywt.gapi.taihe.biz.GetScreeningTableResponse> responseObserver){
        getScreeningTableAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

    com.ywt.gapi.taihe.biz.SubmitScreeningTableResponse submitScreeningTable(com.ywt.gapi.taihe.biz.SubmitScreeningTableRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.biz.SubmitScreeningTableResponse> submitScreeningTableAsync(com.ywt.gapi.taihe.biz.SubmitScreeningTableRequest request){
        return CompletableFuture.completedFuture(submitScreeningTable(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void submitScreeningTable(com.ywt.gapi.taihe.biz.SubmitScreeningTableRequest request, StreamObserver<com.ywt.gapi.taihe.biz.SubmitScreeningTableResponse> responseObserver){
        submitScreeningTableAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

    com.ywt.gapi.taihe.biz.GetAvailableBookNumResponse getAvailableBookNum(com.ywt.gapi.taihe.biz.GetAvailableBookNumRequest request);

    default CompletableFuture<com.ywt.gapi.taihe.biz.GetAvailableBookNumResponse> getAvailableBookNumAsync(com.ywt.gapi.taihe.biz.GetAvailableBookNumRequest request){
        return CompletableFuture.completedFuture(getAvailableBookNum(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getAvailableBookNum(com.ywt.gapi.taihe.biz.GetAvailableBookNumRequest request, StreamObserver<com.ywt.gapi.taihe.biz.GetAvailableBookNumResponse> responseObserver){
        getAvailableBookNumAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }






}
